"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var styled_1 = __importDefault(require("@emotion/styled"));
var core_1 = require("@emotion/core");
var utilities_1 = require("../utilities/utilities");
var wrapper_1 = __importDefault(require("../wrapper/wrapper"));
var dProps = {
    loading: true,
    size: 40,
    colors: [utilities_1.Colors.Purple, utilities_1.Colors.Purple, utilities_1.Colors.Purple, utilities_1.Colors.Purple]
};
var BrokenCirclesLoader = function (props) {
    var loading = props.loading, size = props.size, pause = props.pause, colors = props.colors;
    var BrokenCirclesAnim = core_1.keyframes(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        from {\n            transform: rotate(0deg);\n        }\n\n        to {\n            transform: rotate(360deg);\n        }\n    "], ["\n        from {\n            transform: rotate(0deg);\n        }\n\n        to {\n            transform: rotate(360deg);\n        }\n    "])));
    var BrokenCircles = styled_1.default('div')(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n        position: absolute;\n        width: inherit;\n        height: inherit;\n\n        div {\n            &:nth-of-type(1) {\n                animation: ", " 4s infinite linear;\n                animation-play-state: ", ";\n                width: inherit;\n                height: inherit;\n                border-radius: 100%;\n                border-left: 5px solid transparent;\n                border-bottom: 5px solid transparent;\n                border-right: 5px solid transparent;\n                border-top: 5px solid ", ";\n                position: absolute;\n            }\n\n            &:nth-of-type(2) {\n                width: ", ";\n                height: ", ";\n                border-radius: 100%;\n                border-left: 5px solid transparent;\n                border-bottom: 5px solid ", ";\n                border-right: 5px solid transparent;\n                border-top: 5px solid transparent;\n                animation: ", " 3s infinite reverse linear;\n                animation-play-state: ", ";\n                position: absolute;\n                top: 5px;\n                left: 5px;\n            }\n\n            &:nth-of-type(3) {\n                width: ", ";\n                height: ", ";\n                border-radius: 100%;\n                border-left: 5px solid transparent;\n                border-top: 5px solid ", ";\n                border-right: 5px solid transparent;\n                border-bottom: 5px solid transparent;\n                animation: ", " 2s infinite linear;\n                animation-play-state: ", ";\n                position: absolute;\n                top: 10px;\n                left: 10px;\n            }\n\n            &:nth-of-type(4) {\n                width: ", ";\n                height: ", ";\n                border-radius: 100%;\n                border-left: 5px solid transparent;\n                border-bottom: 5px solid ", ";\n                border-right: 5px solid transparent;\n                border-top: 5px solid transparent;\n                animation: ", " 1s infinite reverse linear;\n                animation-play-state: ", ";\n                position: absolute;\n                top: 15px;\n                left: 15px;\n            }\n        }\n    "], ["\n        position: absolute;\n        width: inherit;\n        height: inherit;\n\n        div {\n            &:nth-of-type(1) {\n                animation: ", " 4s infinite linear;\n                animation-play-state: ", ";\n                width: inherit;\n                height: inherit;\n                border-radius: 100%;\n                border-left: 5px solid transparent;\n                border-bottom: 5px solid transparent;\n                border-right: 5px solid transparent;\n                border-top: 5px solid ", ";\n                position: absolute;\n            }\n\n            &:nth-of-type(2) {\n                width: ", ";\n                height: ", ";\n                border-radius: 100%;\n                border-left: 5px solid transparent;\n                border-bottom: 5px solid ", ";\n                border-right: 5px solid transparent;\n                border-top: 5px solid transparent;\n                animation: ", " 3s infinite reverse linear;\n                animation-play-state: ", ";\n                position: absolute;\n                top: 5px;\n                left: 5px;\n            }\n\n            &:nth-of-type(3) {\n                width: ", ";\n                height: ", ";\n                border-radius: 100%;\n                border-left: 5px solid transparent;\n                border-top: 5px solid ", ";\n                border-right: 5px solid transparent;\n                border-bottom: 5px solid transparent;\n                animation: ", " 2s infinite linear;\n                animation-play-state: ", ";\n                position: absolute;\n                top: 10px;\n                left: 10px;\n            }\n\n            &:nth-of-type(4) {\n                width: ", ";\n                height: ", ";\n                border-radius: 100%;\n                border-left: 5px solid transparent;\n                border-bottom: 5px solid ", ";\n                border-right: 5px solid transparent;\n                border-top: 5px solid transparent;\n                animation: ", " 1s infinite reverse linear;\n                animation-play-state: ", ";\n                position: absolute;\n                top: 15px;\n                left: 15px;\n            }\n        }\n    "])), BrokenCirclesAnim, utilities_1.pauseAnim(pause), colors ? "" + colors[0] : "" + dProps.colors[0], size ? size * 0.8 + "px" : dProps.size * 0.8 + "px", size ? size * 0.8 + "px" : dProps.size * 0.8 + "px", colors ? "" + colors[1] : "" + dProps.colors[1], BrokenCirclesAnim, utilities_1.pauseAnim(pause), size ? size * 0.6 + "px" : dProps.size * 0.6 + "px", size ? size * 0.6 + "px" : dProps.size * 0.6 + "px", colors ? "" + colors[2] : "" + dProps.colors[2], BrokenCirclesAnim, utilities_1.pauseAnim(pause), size ? size * 0.4 + "px" : dProps.size * 0.4 + "px", size ? size * 0.4 + "px" : dProps.size * 0.4 + "px", colors ? "" + colors[3] : "" + dProps.colors[3], BrokenCirclesAnim, utilities_1.pauseAnim(pause));
    return (react_1.default.createElement(wrapper_1.default, { size: size, loading: loading, dPropsSize: dProps.size },
        react_1.default.createElement(BrokenCircles, null,
            react_1.default.createElement("div", null),
            react_1.default.createElement("div", null),
            react_1.default.createElement("div", null),
            react_1.default.createElement("div", null))));
};
exports.default = BrokenCirclesLoader;
var templateObject_1, templateObject_2;
