"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var styled_1 = __importDefault(require("@emotion/styled"));
var core_1 = require("@emotion/core");
var utilities_1 = require("../utilities/utilities");
var wrapper_1 = __importDefault(require("../wrapper/wrapper"));
var dProps = {
    loading: true,
    duration: 2,
    size: 45,
    color: utilities_1.Colors.Purple
};
var DotsLoader = function (props) {
    var loading = props.loading, size = props.size, pause = props.pause, color = props.color, duration = props.duration;
    var Dot1 = core_1.keyframes(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        0%   { transform: rotate(90deg); }\n        0%  { transform: rotate(90deg); }\n        50%  { transform: rotate(180deg); }\n        75%  { transform: rotate(270deg); }\n        100% { transform: rotate(360deg); }\n    "], ["\n        0%   { transform: rotate(90deg); }\n        0%  { transform: rotate(90deg); }\n        50%  { transform: rotate(180deg); }\n        75%  { transform: rotate(270deg); }\n        100% { transform: rotate(360deg); }\n    "])));
    var Dot2 = core_1.keyframes(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n        0%   { transform: rotate(90deg); }\n        25%  { transform: rotate(90deg); }\n        25%  { transform: rotate(180deg); }\n        75%  { transform: rotate(270deg); }\n        100% { transform: rotate(360deg); }\n    "], ["\n        0%   { transform: rotate(90deg); }\n        25%  { transform: rotate(90deg); }\n        25%  { transform: rotate(180deg); }\n        75%  { transform: rotate(270deg); }\n        100% { transform: rotate(360deg); }\n    "])));
    var Dot3 = core_1.keyframes(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n        0%   { transform: rotate(90deg); }\n        25%  { transform: rotate(90deg); }\n        50%  { transform: rotate(180deg); }\n        50%  { transform: rotate(270deg); }\n        100% { transform: rotate(360deg); }\n    "], ["\n        0%   { transform: rotate(90deg); }\n        25%  { transform: rotate(90deg); }\n        50%  { transform: rotate(180deg); }\n        50%  { transform: rotate(270deg); }\n        100% { transform: rotate(360deg); }\n    "])));
    var Dot4 = core_1.keyframes(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n        0%   { transform: rotate(90deg); }\n        25%  { transform: rotate(90deg); }\n        50%  { transform: rotate(180deg); }\n        75%  { transform: rotate(270deg); }\n        75% { transform: rotate(360deg); }\n        100% { transform: rotate(360deg); }\n    "], ["\n        0%   { transform: rotate(90deg); }\n        25%  { transform: rotate(90deg); }\n        50%  { transform: rotate(180deg); }\n        75%  { transform: rotate(270deg); }\n        75% { transform: rotate(360deg); }\n        100% { transform: rotate(360deg); }\n    "])));
    var Dots = styled_1.default('div')(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n        width: inherit;\n        height: inherit;\n\n        div {\n            content: '';\n            position: absolute;\n            width: ", ";\n            height: ", ";\n            background: ", ";\n            top: ", ";\n            left: ", ";\n            transform-origin: ", " ", ";\n            border-radius: 50%;\n            animation: ", " ", " infinite cubic-bezier(0.5, 0, 0.5, 1);\n            animation-play-state: ", ";\n\n            &:nth-of-type(2) {\n                top: ", ";\n                left: auto;\n                right: ", ";\n                transform-origin: ", " ", ";\n                animation: ", " ", " infinite cubic-bezier(0.5, 0, 0.5, 1);\n                animation-play-state: ", ";\n            }\n\n            &:nth-of-type(3) {\n                top: auto;\n                left: auto;\n                right: ", ";\n                bottom: ", ";\n                transform-origin: ", " ", ";\n                animation: ", " ", " infinite cubic-bezier(0.5, 0, 0.5, 1);\n                animation-play-state: ", ";\n            }\n\n            &:nth-of-type(4) {\n                top: auto;\n                bottom: ", ";\n                transform-origin: ", " ", ";\n                animation: ", " ", " infinite cubic-bezier(0.5, 0, 0.5, 1);\n                animation-play-state: ", ";\n            }\n        }\n    "], ["\n        width: inherit;\n        height: inherit;\n\n        div {\n            content: '';\n            position: absolute;\n            width: ", ";\n            height: ", ";\n            background: ", ";\n            top: ", ";\n            left: ", ";\n            transform-origin: ", " ", ";\n            border-radius: 50%;\n            animation: ", " ", " infinite cubic-bezier(0.5, 0, 0.5, 1);\n            animation-play-state: ", ";\n\n            &:nth-of-type(2) {\n                top: ", ";\n                left: auto;\n                right: ", ";\n                transform-origin: ", " ", ";\n                animation: ", " ", " infinite cubic-bezier(0.5, 0, 0.5, 1);\n                animation-play-state: ", ";\n            }\n\n            &:nth-of-type(3) {\n                top: auto;\n                left: auto;\n                right: ", ";\n                bottom: ", ";\n                transform-origin: ", " ", ";\n                animation: ", " ", " infinite cubic-bezier(0.5, 0, 0.5, 1);\n                animation-play-state: ", ";\n            }\n\n            &:nth-of-type(4) {\n                top: auto;\n                bottom: ", ";\n                transform-origin: ", " ", ";\n                animation: ", " ", " infinite cubic-bezier(0.5, 0, 0.5, 1);\n                animation-play-state: ", ";\n            }\n        }\n    "])), size ? size * 0.27 + "px" : dProps.size * 0.27 + "px", size ? size * 0.27 + "px" : dProps.size * 0.27 + "px", color ? "" + color : "" + dProps.color, size ? size * 0.17 + "px" : dProps.size * 0.17 + "px", size ? size * 0.17 + "px" : dProps.size * 0.17 + "px", size ? size * 0.33 + "px" : dProps.size * 0.33 + "px", size ? size * 0.33 + "px" : dProps.size * 0.33 + "px", Dot1, utilities_1.loaderDuration(duration, dProps.duration), utilities_1.pauseAnim(pause), size ? size * 0.17 + "px" : dProps.size * 0.17 + "px", size ? size * 0.17 + "px" : dProps.size * 0.17 + "px", size ? "-" + size * 0.07 + "px" : "-" + dProps.size * 0.07 + "px", size ? size * 0.33 + "px" : dProps.size * 0.33 + "px", Dot2, utilities_1.loaderDuration(duration, dProps.duration), utilities_1.pauseAnim(pause), size ? size * 0.17 + "px" : dProps.size * 0.17 + "px", size ? size * 0.17 + "px" : dProps.size * 0.17 + "px", size ? "-" + size * 0.07 + "px" : "-" + dProps.size * 0.07 + "px", size ? "-" + size * 0.07 + "px" : "-" + dProps.size * 0.07 + "px", Dot3, utilities_1.loaderDuration(duration, dProps.duration), utilities_1.pauseAnim(pause), size ? size * 0.17 + "px" : dProps.size * 0.17 + "px", size ? size * 0.33 + "px" : dProps.size * 0.33 + "px", size ? "-" + size * 0.07 + "px" : "-" + dProps.size * 0.07 + "px", Dot4, utilities_1.loaderDuration(duration, dProps.duration), utilities_1.pauseAnim(pause));
    return (react_1.default.createElement(wrapper_1.default, { size: size, loading: loading, dPropsSize: dProps.size },
        react_1.default.createElement(Dots, null,
            react_1.default.createElement("div", null),
            react_1.default.createElement("div", null),
            react_1.default.createElement("div", null),
            react_1.default.createElement("div", null))));
};
exports.default = DotsLoader;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
