"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var styled_1 = __importDefault(require("@emotion/styled"));
var core_1 = require("@emotion/core");
var utilities_1 = require("../utilities/utilities");
var wrapper_1 = __importDefault(require("../wrapper/wrapper"));
var dProps = {
    loading: true,
    size: 60,
    duration: 1,
    color: utilities_1.Colors.Purple
};
var EightBitLoader = function (props) {
    var loading = props.loading, size = props.size, pause = props.pause, duration = props.duration, color = props.color;
    var EightBitAnim = core_1.keyframes(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        0% {\n            box-shadow: \n            0px -30px ", ", \n            10px -30px ", ", \n            20px -20px ", ", \n            30px -10px ", ", \n            30px 0px ", ", \n            30px 10px ", ", \n            20px 20px ", ", \n            10px 30px ", ", \n            0px 30px transparent, \n            -10px 30px transparent, \n            -20px 20px transparent, \n            -30px 10px transparent, \n            -30px 0px transparent, \n            -30px -10px transparent, \n            -20px -20px transparent,\n            -10px -30px transparent;\n        }\n        6.25% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n          12.5% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n          18.75% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n          25% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n          31.25% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n          37.5% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n          43.75% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px transparent;\n          }\n          50% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          56.25% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          62.5% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          68.75% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          75% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          81.25% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          87.5% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          93.75% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px ", ";\n          }\n          100% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n    "], ["\n        0% {\n            box-shadow: \n            0px -30px ", ", \n            10px -30px ", ", \n            20px -20px ", ", \n            30px -10px ", ", \n            30px 0px ", ", \n            30px 10px ", ", \n            20px 20px ", ", \n            10px 30px ", ", \n            0px 30px transparent, \n            -10px 30px transparent, \n            -20px 20px transparent, \n            -30px 10px transparent, \n            -30px 0px transparent, \n            -30px -10px transparent, \n            -20px -20px transparent,\n            -10px -30px transparent;\n        }\n        6.25% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n          12.5% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n          18.75% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n          25% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n          31.25% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n          37.5% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n          43.75% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px ", ", \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px transparent;\n          }\n          50% {\n            box-shadow: \n              0px -30px transparent, \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px ", ", \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          56.25% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px transparent, \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px ", ", \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          62.5% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px transparent, \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px ", ", \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          68.75% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px transparent, \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px ", ", \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          75% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px transparent, \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px ", ", \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          81.25% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px transparent, \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px ", ", \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          87.5% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px transparent, \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px ", ",\n              -10px -30px ", ";\n          }\n          93.75% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px transparent, \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px ", ";\n          }\n          100% {\n            box-shadow: \n              0px -30px ", ", \n              10px -30px ", ", \n              20px -20px ", ", \n              30px -10px ", ", \n              30px 0px ", ", \n              30px 10px ", ", \n              20px 20px ", ", \n              10px 30px ", ", \n              0px 30px transparent, \n              -10px 30px transparent, \n              -20px 20px transparent, \n              -30px 10px transparent, \n              -30px 0px transparent, \n              -30px -10px transparent, \n              -20px -20px transparent,\n              -10px -30px transparent;\n          }\n    "])), color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color, color ? color : dProps.color);
    var EightBit = styled_1.default('div')(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n        animation: ", " ", " linear infinite;\n        animation-play-state: ", ";\n        height: 10px;\n        width: 10px;\n        transform: scale(", ");\n    "], ["\n        animation: ", " ", " linear infinite;\n        animation-play-state: ", ";\n        height: 10px;\n        width: 10px;\n        transform: scale(", ");\n    "])), EightBitAnim, utilities_1.loaderDuration(duration, dProps.duration), utilities_1.pauseAnim(pause), size ? size / 100 : dProps.size / 100);
    return (react_1.default.createElement(wrapper_1.default, { size: size, loading: loading, dPropsSize: dProps.size },
        react_1.default.createElement(EightBit, null)));
};
exports.default = EightBitLoader;
var templateObject_1, templateObject_2;
